package db

import (
	"time"

	"git.janky.solutions/finn/lockserver/openapi"
)

func (u GetAllUserCodesRow) OpenAPI() openapi.UserCode {
	resp := openapi.UserCode{Code: &u.Code}

	if u.Name.Valid {
		resp.User = &u.Name.String
	}

	if u.Start.Valid {
		start := u.Start.Time.Format(time.RFC3339)
		resp.Starts = &start
	}

	if u.End.Valid {
		end := u.End.Time.Format(time.RFC3339)
		resp.Ends = &end
	}

	return resp
}
